(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;

(function(){

/////////////////////////////////////////////////////////////////////////////////////////
//                                                                                     //
// packages/fongandrew_find-and-modify/packages/fongandrew_find-and-modify.js          //
//                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////
                                                                                       //
(function () {                                                                         // 1
                                                                                       // 2
//////////////////////////////////////////////////////////////////////////////////     // 3
//                                                                              //     // 4
// packages/fongandrew:find-and-modify/find_and_modify.js                       //     // 5
//                                                                              //     // 6
//////////////////////////////////////////////////////////////////////////////////     // 7
                                                                                //     // 8
(function() {                                                                   // 1   // 9
  'use strict';                                                                 // 2   // 10
  // Code adapted from https://github.com/meteor/meteor/issues/1070             // 3   // 11
                                                                                // 4   // 12
  // Helper func to run shared validation code                                  // 5   // 13
  function validate(collection, args) {                                         // 6   // 14
    if(!collection._name)                                                       // 7   // 15
        throw new Meteor.Error(405,                                             // 8   // 16
                               "findAndModify: Must have collection name.");    // 9   // 17
                                                                                // 10  // 18
    if(!args)                                                                   // 11  // 19
      throw new Meteor.Error(405, "findAndModify: Must have args.");            // 12  // 20
                                                                                // 13  // 21
    if(!args.query)                                                             // 14  // 22
      throw new Meteor.Error(405, "findAndModify: Must have query.");           // 15  // 23
                                                                                // 16  // 24
    if(!args.update && !args.remove)                                            // 17  // 25
      throw new Meteor.Error(405,                                               // 18  // 26
                             "findAndModify: Must have update or remove.");     // 19  // 27
  };                                                                            // 20  // 28
                                                                                // 21  // 29
  if (Meteor.isServer) {                                                        // 22  // 30
    Mongo.Collection.prototype.findAndModify = function(args){                  // 23  // 31
      validate(this, args);                                                     // 24  // 32
                                                                                // 25  // 33
      var q = {};                                                               // 26  // 34
      q.query = args.query || {};                                               // 27  // 35
      q.sort = args.sort || {};                                                 // 28  // 36
      if (args.update)                                                          // 29  // 37
        q.update = args.update;                                                 // 30  // 38
                                                                                // 31  // 39
      q.options = {};                                                           // 32  // 40
      if (args.new !== undefined)                                               // 33  // 41
        q.options.new = args.new;                                               // 34  // 42
      if (args.remove !== undefined)                                            // 35  // 43
        q.options.remove = args.remove;                                         // 36  // 44
      if (args.upsert !== undefined)                                            // 37  // 45
        q.options.upsert = args.upsert;                                         // 38  // 46
      if (args.fields !== undefined)                                            // 39  // 47
        q.options.fields = args.fields;                                         // 40  // 48
                                                                                // 41  // 49
      var db = MongoInternals.defaultRemoteCollectionDriver().mongo.db;         // 42  // 50
      var collectionObj = db.collection(this._name);                            // 43  // 51
                                                                                // 44  // 52
      var wrappedFunc = Meteor.wrapAsync(collectionObj.findAndModify,           // 45  // 53
                                         collectionObj);                        // 46  // 54
      return wrappedFunc(                                                       // 47  // 55
        q.query,                                                                // 48  // 56
        q.sort,                                                                 // 49  // 57
        q.update,                                                               // 50  // 58
        q.options                                                               // 51  // 59
      );                                                                        // 52  // 60
    };                                                                          // 53  // 61
  }                                                                             // 54  // 62
                                                                                // 55  // 63
  if (Meteor.isClient) {                                                        // 56  // 64
    Mongo.Collection.prototype.findAndModify = function(args) {                 // 57  // 65
      validate(this, args);                                                     // 58  // 66
                                                                                // 59  // 67
      var findOptions = {};                                                     // 60  // 68
      if (args.sort !== undefined)                                              // 61  // 69
        findOptions.sort = args.sort;                                           // 62  // 70
      if (args.fields !== undefined)                                            // 63  // 71
        findOptions.fields = args.fields;                                       // 64  // 72
      if (args.skip !== undefined)                                              // 65  // 73
        findOptions.skip = args.skip;                                           // 66  // 74
                                                                                // 67  // 75
      var ret = this.findOne(args.query, findOptions);                          // 68  // 76
      if (args.remove) {                                                        // 69  // 77
        if (ret) this.remove({_id: ret._id});                                   // 70  // 78
      }                                                                         // 71  // 79
                                                                                // 72  // 80
      else {                                                                    // 73  // 81
        if (args.upsert && !ret) {                                              // 74  // 82
          var writeResult = this.upsert(args.query, args.update);               // 75  // 83
          if (writeResult.insertedId && args.new)                               // 76  // 84
            return this.findOne({_id: writeResult.insertedId}, findOptions);    // 77  // 85
          else if (findOptions.sort)                                            // 78  // 86
            return {};                                                          // 79  // 87
          return null;                                                          // 80  // 88
        }                                                                       // 81  // 89
                                                                                // 82  // 90
        else if (ret) {                                                         // 83  // 91
                                                                                // 84  // 92
          // If we're in a simulation, it's safe to call update with normal     // 85  // 93
          // selectors (which is needed, e.g., for modifiers with positional    // 86  // 94
          // operators). Otherwise, we'll have to do an _id only update to      // 87  // 95
          // get around the restriction that lets untrusted (e.g. client)       // 88  // 96
          // code update collections by _id only.                               // 89  // 97
          var enclosing = DDP._CurrentInvocation.get();                         // 90  // 98
          var alreadyInSimulation = enclosing && enclosing.isSimulation;        // 91  // 99
          if (alreadyInSimulation) {                                            // 92  // 100
            // Add _id to query because Meteor's update doesn't include certain // 93  // 101
            // options that the full findAndModify does (like sort). Create     // 94  // 102
            // shallow copy before update so as not to mess with user's         // 95  // 103
            // original query object                                            // 96  // 104
            var updatedQuery = {};                                              // 97  // 105
            for (var prop in args.query) {                                      // 98  // 106
              updatedQuery[prop] = args.query[prop];                            // 99  // 107
            }                                                                   // 100
            updatedQuery._id = ret._id;                                         // 101
            this.update(updatedQuery, args.update);                             // 102
          }                                                                     // 103
                                                                                // 104
          else {                                                                // 105
            this.update({_id: ret._id}, args.update);                           // 106
          }                                                                     // 107
                                                                                // 108
          if (args.new)                                                         // 109
            return this.findOne({_id: ret._id}, findOptions);                   // 110
        }                                                                       // 111
      }                                                                         // 112
                                                                                // 113
      return ret;                                                               // 114
    };                                                                          // 115
  }                                                                             // 116
                                                                                // 117
})();                                                                           // 118
                                                                                // 119
                                                                                // 120
                                                                                // 121
//////////////////////////////////////////////////////////////////////////////////     // 130
                                                                                       // 131
}).call(this);                                                                         // 132
                                                                                       // 133
/////////////////////////////////////////////////////////////////////////////////////////

}).call(this);


/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['fongandrew:find-and-modify'] = {};

})();

//# sourceMappingURL=fongandrew_find-and-modify.js.map
